import StringIO
import re
from genshi.core import Markup
from trac.wiki import Formatter
from trac.core import Component, implements
from trac.wiki.api import IWikiMacroProvider



tr_list1=[
    [r"\\_",r"_"]
]
tr_list2 = [
    [r"\$\$",r"\$\$",r"\n{{{\n#!latex\n\n",r"\n}}}\n"],
    [r"\$",r"\$",r"\(",r"\)"],
    [r"\\subsubsection{",r"}",r" ==== ",r" ==== "],
    [r"\\subsection{",r"}",r" === ",r" === "],
    [r"\\section{",r"}",r" == ",r" == "],
    [r"\\title{",r"}",r" = ",r" = "],
    ]

class tractex2wiki(Component):
    implements(IWikiMacroProvider)

    # IWikiMacroProvider methods
    def get_macros(self):
        return ('traclatex', 'TracLatex', 'TracLaTeX')

    def get_macro_description(self, name):
        return 'convert tex to wiki and mathjax'

    def expand_macro(self, formatter, name, content):
        if name.lower() == "traclatex":
             out = StringIO.StringIO()
             Formatter(self.env, formatter.context).format(self.latex2wiki(content), out)
             return Markup(out.getvalue())

    def latex2wiki(self, in_stream):
       ms=re.search('\\\\begin\{document\}(.*?)\\\\end\{document\}',in_stream,re.DOTALL)
       if ms:
           stream=ms.group(1)
       else:
           stream=in_stream
       for reg in tr_list1:
           p=re.compile(reg[0])
           stream=re.sub(p,reg[1],stream)
           print stream
       for reg in tr_list2:
           p=re.compile(reg[0]+'(.*?)'+reg[1],re.DOTALL)
           stream=re.sub(p,reg[2]+r'\1'+reg[3],stream,re.DOTALL)
       return stream

